\ Dataflash commands

hex

\ **read

\ Continuous Array Read, bypass buffers
: dfcar ( 24:4r,11P,9B -- ) E8 dfcom (32x) ;

\ Main memory page read, bypass buffers
: dfmr  ( 24:4r,11P,9B -- ) D2 dfcom (32x) ; 

\ Buffer 1 read
: df1r  ( 24:15r,9B -- ) D4 dfcom (8x) ; 

\ Buffer 2 read
: df2r  ( 24:15r,9B -- ) D6 dfcom (8x) ;

\ Status register read
: dfsr  ( -- n ) cstoggle D7 spirw spirw ;

\ wait till df is ready again
: dfsr-ok ( -- )
  begin dfsr 9c = until ;

\ **write  

\  Buffer 1 write
: df1w  ( 24:15r,9B -- ) 84 dfcom () ;

\  Buffer 2 write
: df2w  ( 24:15r,9B -- ) 87 dfcom () ;

\ Buffer 1 to main memory page program with built-in erase
: df1me ( 24:4r,11P,9x -- ) 83 dfcom () ;

: df2me ( 24:4r,11P,9x -- ) 86 dfcom () ;
\ Buffer 2 to main memory page program with built-in erase

\ Buffer 1 to main memory page program without built-in erase
: df1m  ( 24:4r,11P,9x -- ) 88 dfcom () ;

\ Buffer 2 to main memory page program without built-in erase
: df2m  ( 24:4r,11P,9x -- ) 89 dfcom () ;

 \ Page erase
: dfe   ( 24:4r,11P,9x -- ) 81 dfcom () ;

 \ Block erase
: dfee  ( 24:4r,8P,12x -- ) 50 dfcom () ;

\ Main memory page program through buffer 1; cstoggle after writing buffer!
: df1wm ( 24:4r,11P,9B -- ) 82 dfcom () ;

\ Main memory page program through buffer 2; cstoggle after writing buffer!
: df2wm ( 24:4r,11P,9B -- ) 85 dfcom () ;


\ **additional

\ Main memory page to buffer 1 transfer
: dfm1   ( 24:4r,11P,9x -- ) 53 dfcom () ;

\ Main memory page to buffer 2 transfer
: dfm2   ( 24:4r,11P,9x -- ) 55 dfcom () ;

\ Main memory page to buffer 1 compare
: dfm2c  ( 24:4r,11P,9x -- ) 60 dfcom () ;

\ Main memory page to buffer 2 compare
: dfm2c  ( 24:4r,11P,9x -- ) 61 dfcom () ;

\ Auto page rewrite through buffer 1
: dfm1rw ( 24:4r,11P,9x -- ) 58 dfcom () ;

\ Auto page rewrite through buffer 2
: dfm2rw ( 24:4r,11P,9x -- ) 59 dfcom () ;

\ finis
