; Initialisation for Dataflash 45db00..64.
; Enable SPI in Master mode, mode 3, Fosc/4, dobble speed. (1)
; ( -- )
VE_dfinit:
    .db $06, "dfinit",0
    .dw VE_HEAD
    .set VE_HEAD  = VE_dfinit
XT_dfinit:
    .dw PFA_dfinit
PFA_dfinit:
    ldi temp0,$FF ; all set.
    out PORTB, temp0
    ldi temp0,$F7 ; % 1111 0111 (Master Input), others set == output.
    out DDRB, temp0
    ldi temp0,$5C ; % 0101 1100 SPE, MSTR, CPOL, CPHA set.
    out SPCR, temp0
    ldi temp0,$01 ; % 0000 0001 SPI2x set, we get Fosc/2.
    out SPSR, temp0
    jmp DO_NEXT


; SPI read/write of dataflash
; Send byte to data flash, get byte returnd by previos command.
; ( txbyte -- rxbyte)
VE_spirw:
    .db $05, "spirw"
    .dw VE_HEAD
    .set VE_HEAD  = VE_spirw
XT_spirw:
    .dw PFA_spirw
PFA_spirw: 
    ld temp1, Y+  ; txbyte spdr c!
    ld temp0, Y+
    out_ SPDR, temp0
PFA_spirw1:   
    in_ temp0,SPSR 
    sbrs temp0,7      ; wait till tcomplete
    rjmp PFA_spirw1   
    in_ temp0,SPDR    ; rxbyte c@
    st -Y, temp0
    st -Y, zeroh
    jmp DO_NEXT

; finis  

; notes
; (1) SPI settings
;    $4C constant SPCR  \ SPI control register
;    Bit 7 – SPIE: SPI Interrupt Enable
;    Bit 6 – SPE: SPI Enable = 1
;    Bit 5 – DORD: Data Order = 0 == MSB first
;    Bit 4 – MSTR: Master/Slave Select = 1
;    Bit 3 – CPOL: Clock Polarity = 1 == HI is SCK idle.
;    Bit 2 – CPHA: Clock Phase = 1 == setup/sample SCK
;    Bits 1, 0 – SPR1, SPR0: SPI Clock Rate Select 1 and 0; 00=fosc/4
;    
;    $4D constant SPSR  \ SPI status register
;    Bit 7 – SPIF: SPI Interrupt Flag
;    Bit 6 – WCOL: Write Colision Flag
;    Bit 5..1 – Res: Reserved Bits
;    Bit 0 – SPI2X: Double SPI Speed Bit
;    
;    $4E constant SPDR  \ SPI data register
;    Writing to the register initiates data transmission.
;    Reading the register causes the Shift Register Receive buffer to be read.
;